import * as React from 'react';
import type { GetContainer } from 'rc-util/lib/PortalWrapper';
import type { DrawerPopupProps } from './DrawerPopup';
export declare type Placement = 'left' | 'top' | 'right' | 'bottom';
export interface DrawerProps extends Omit<DrawerPopupProps, 'prefixCls'> {
    prefixCls?: string;
    open?: boolean;
    onClose?: (e: React.MouseEvent | React.KeyboardEvent) => void;
    /** @deprecated Only work on Portal mode. You can replace with rootClassName instead */
    wrapperClassName?: string;
    destroyOnClose?: boolean;
    getContainer?: GetContainer | false;
}
declare const Drawer: React.FC<DrawerProps>;
export default Drawer;
