import * as React from 'react';
import type { CSSMotionProps } from 'rc-motion';
import type ScrollLocker from 'rc-util/lib/Dom/scrollLocker';
export declare type Placement = 'left' | 'right' | 'top' | 'bottom';
export interface DrawerPopupProps {
    prefixCls: string;
    open?: boolean;
    inline?: boolean;
    push?: {
        distance?: number | string;
    };
    forceRender?: boolean;
    autoFocus?: boolean;
    keyboard?: boolean;
    scrollLocker?: ScrollLocker;
    rootClassName?: string;
    rootStyle?: React.CSSProperties;
    zIndex?: number;
    placement?: Placement;
    className?: string;
    style?: React.CSSProperties;
    children?: React.ReactNode;
    width?: number | string;
    height?: number | string;
    contentWrapperStyle?: React.CSSProperties;
    mask?: boolean;
    maskClosable?: boolean;
    maskClassName?: React.CSSProperties;
    maskStyle?: React.CSSProperties;
    motion?: CSSMotionProps | ((placement: Placement) => CSSMotionProps);
    maskMotion?: CSSMotionProps;
    afterOpenChange?: (open: boolean) => void;
    onClose?: (event: React.MouseEvent<HTMLElement> | React.KeyboardEvent<HTMLElement>) => void;
}
export default function DrawerPopup(props: DrawerPopupProps): JSX.Element;
